Debian Bug report logs - #629899
ap_get_local_host fails when eth0 has IPv6 only (can't determine the FQDN), e.g. with DHCP at boot

version graph

Package: libapr1; Maintainer for libapr1 is Debian Apache Maintainers <debian-apache@lists.debian.org>; Source for libapr1 is src:apr.

Reported by: Vincent Lefevre <vincent@vinc17.net>

Date: Thu, 9 Jun 2011 12:12:12 UTC

Severity: important

Tags: patch, upstream

Fixed in version apr/1.4.6-3

Done: Stefan Fritsch <sf@debian.org>

Bug is archived. No further changes may be made.

Forwarded to https://issues.apache.org/bugzilla/show_bug.cgi?id=52709

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Apache Maintainers <debian-apache@lists.debian.org>:
Bug#629899; Package apache2.2-common. (Thu, 09 Jun 2011 12:12:19 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.net>:
New Bug report received and forwarded. Copy sent to Debian Apache Maintainers <debian-apache@lists.debian.org>. (Thu, 09 Jun 2011 12:12:19 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.net>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: apache2: apr_sockaddr_info_get() failed / Could not reliably determine the server's FQDN
Date: Thu, 9 Jun 2011 14:11:09 +0200
Package: apache2.2-common
Version: 2.2.19-1
Severity: normal

After installing the new kernel 2.6.39-2-amd64 and rebooting, I got
in /var/log/boot:

Thu Jun  9 13:41:49 2011: Starting web server: apache2apache2: apr_sockaddr_info_get() failed for ypig
Thu Jun  9 13:41:51 2011: apache2: Could not reliably determine the server's fully qualified domain name, using 127.0.0.1 for ServerName
Thu Jun  9 13:41:51 2011: .

This error didn't occur with previous kernels, and doesn't occur
after a manual restart with:

  /etc/init.d/apache2 restart

My /etc/hosts contains:

127.0.0.1       localhost
127.0.1.1       ypig.lip.ens-lyon.fr    ypig

# The following lines are desirable for IPv6 capable hosts
::1     localhost ip6-localhost ip6-loopback
fe00::0 ip6-localnet
ff00::0 ip6-mcastprefix
ff02::1 ip6-allnodes
ff02::2 ip6-allrouters

and /etc/nsswitch.conf contains the line:

hosts:          files mdns4_minimal [NOTFOUND=return] dns mdns4

-- Package-specific info:
List of enabled modules from 'apache2 -M':
  alias auth_basic authn_file authz_default authz_groupfile
  authz_host authz_svn authz_user autoindex cgi cgid dav dav_svn
  deflate dir env mime negotiation perl python reqtimeout setenvif
  status

-- System Information:
Debian Release: wheezy/sid
  APT prefers unstable
  APT policy: (500, 'unstable'), (500, 'testing'), (500, 'stable'), (1, 'experimental')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.39-2-amd64 (SMP w/8 CPU cores)
Locale: LANG=POSIX, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages apache2 depends on:
ii  apache2-mpm-worker            2.2.19-1   Apache HTTP Server - high speed th
ii  apache2.2-common              2.2.19-1   Apache HTTP Server common files

apache2 recommends no packages.

apache2 suggests no packages.

Versions of packages apache2.2-common depends on:
ii  apache2-utils                 2.2.19-1   utility programs for webservers
ii  apache2.2-bin                 2.2.19-1   Apache HTTP Server common binary f
ii  lsb-base                      3.2-27     Linux Standard Base 3.2 init scrip
ii  mime-support                  3.51-1     MIME files 'mime.types' & 'mailcap
ii  perl                          5.12.3-7   Larry Wall's Practical Extraction 
ii  procps                        1:3.2.8-10 /proc file system utilities

Versions of packages apache2.2-common recommends:
ii  ssl-cert                      1.0.28     simple debconf wrapper for OpenSSL

Versions of packages apache2.2-common suggests:
ii  apache2-doc         2.2.19-1             Apache HTTP Server documentation
pn  apache2-suexec | ap <none>               (no description available)
ii  chromium [www-brows 11.0.696.71~r86024-1 Chromium browser
ii  epiphany-browser [w 2.30.6-2             Intuitive GNOME web browser
ii  iceape-browser [www 2.0.14-2             Iceape Navigator (Internet browser
ii  iceweasel [www-brow 3.5.19-2             Web browser based on Firefox
ii  links [www-browser] 2.3~pre1-1+b1        Web browser running in text mode
ii  links2 [www-browser 2.3~pre1-1+b1        Web browser running in both graphi
ii  lynx-cur [www-brows 2.8.8dev.8-1         Text-mode WWW Browser with NLS sup
ii  midori [www-browser 0.3.6-1              fast, lightweight graphical web br
ii  uzbl [www-browser]  0.0.0~git.20110412-1 Lightweight Webkit browser followi
ii  w3m [www-browser]   0.5.3-2+b1           WWW browsable pager with excellent

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Apache Maintainers <debian-apache@lists.debian.org>:
Bug#629899; Package apache2.2-common. (Thu, 09 Jun 2011 13:03:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Massimo Manghi <massimo.manghi@unipr.it>:
Extra info received and forwarded to list. Copy sent to Debian Apache Maintainers <debian-apache@lists.debian.org>. (Thu, 09 Jun 2011 13:03:07 GMT) Full text and rfc822 format available.

Message #10 received at 629899@bugs.debian.org (full text, mbox):

From: Massimo Manghi <massimo.manghi@unipr.it>
To: Vincent Lefevre <vincent@vinc17.net>, 629899@bugs.debian.org
Subject: Re: Bug#629899: apache2: apr_sockaddr_info_get() failed / Could not reliably determine the server's FQDN
Date: Thu, 09 Jun 2011 14:41:45 +0200
I've run into the same problem recently upgrading to Linux 2.6.38 on my
home's computer. Symptoms are the shell prompt doesn't show the hostname
I had assigned at install time, being the hostname displayed instead
then one passed through dhcp by the router. A similar problem doesn't
occur at work where we run our own dhcp server and names passed by dhcp
match consistently the ones in /etc/hosts

Could a possible explanation for the workaround you found a latency in
the dhcp negotiation at boot time?

I mean that by the time apache2 is started the interface could be not 
yet configured and the name 'ypig' not yet assigned to it. By the time 
you manually restart apache2 the interface is most likely configured and 
the problem goes away.

If my hypothesis is correct the bug should be filed against the kernel
e/o the libc packages.

hoping to be helpful

 -- Massimo

On 06/09/2011 02:11 PM, Vincent Lefevre wrote:
> Package: apache2.2-common Version: 2.2.19-1 Severity: normal
>
> After installing the new kernel 2.6.39-2-amd64 and rebooting, I got
> in /var/log/boot:
>
> Thu Jun  9 13:41:49 2011: Starting web server: apache2apache2:
> apr_sockaddr_info_get() failed for ypig Thu Jun  9 13:41:51 2011:
> apache2: Could not reliably determine the server's fully qualified
> domain name, using 127.0.0.1 for ServerName Thu Jun  9 13:41:51 2011:
> .
>
> This error didn't occur with previous kernels, and doesn't occur
> after a manual restart with:
>
> /etc/init.d/apache2 restart
>
> My /etc/hosts contains:
>
> 127.0.0.1       localhost 127.0.1.1       ypig.lip.ens-lyon.fr ypig
>
> # The following lines are desirable for IPv6 capable hosts ::1
> localhost ip6-localhost ip6-loopback fe00::0 ip6-localnet ff00::0
> ip6-mcastprefix ff02::1 ip6-allnodes ff02::2 ip6-allrouters
>
> and /etc/nsswitch.conf contains the line:
>
> hosts:          files mdns4_minimal [NOTFOUND=return] dns mdns4
>






Information forwarded to debian-bugs-dist@lists.debian.org, Debian Apache Maintainers <debian-apache@lists.debian.org>:
Bug#629899; Package apache2.2-common. (Thu, 09 Jun 2011 13:39:36 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.net>:
Extra info received and forwarded to list. Copy sent to Debian Apache Maintainers <debian-apache@lists.debian.org>. (Thu, 09 Jun 2011 13:39:36 GMT) Full text and rfc822 format available.

Message #15 received at 629899@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.net>
To: Massimo Manghi <massimo.manghi@unipr.it>
Cc: 629899@bugs.debian.org
Subject: Re: Bug#629899: apache2: apr_sockaddr_info_get() failed / Could not reliably determine the server's FQDN
Date: Thu, 9 Jun 2011 15:32:21 +0200
On 2011-06-09 14:41:45 +0200, Massimo Manghi wrote:
> I've run into the same problem recently upgrading to Linux 2.6.38 on my
> home's computer. Symptoms are the shell prompt doesn't show the hostname
> I had assigned at install time, being the hostname displayed instead
> then one passed through dhcp by the router. A similar problem doesn't
> occur at work where we run our own dhcp server and names passed by dhcp
> match consistently the ones in /etc/hosts
> 
> Could a possible explanation for the workaround you found a latency in
> the dhcp negotiation at boot time?

Here DHCP *must not* be used to determine the FQDN. It is specified
locally in the /etc/hosts file. This is important, in particular
because one may want to run local services depending on it even when
the external network is not available (the administrator may choose
to use DHCP for the FQDN, but should not be forced to).

> I mean that by the time apache2 is started the interface could be not yet
> configured and the name 'ypig' not yet assigned to it. By the time you
> manually restart apache2 the interface is most likely configured and the
> problem goes away.
> 
> If my hypothesis is correct the bug should be filed against the kernel
> e/o the libc packages.

I tried to do an strace to see what was used by apache, but it didn't
succeed.

I have a laptop with the 2.6.39-1-amd64 kernel where DHCP is not used
and /etc/hosts is sufficient to determine the FQDN.

-- 
Vincent Lefèvre <vincent@vinc17.net> - Web: <http://www.vinc17.net/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.net/blog/>
Work: CR INRIA - computer arithmetic / Arénaire project (LIP, ENS-Lyon)




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Apache Maintainers <debian-apache@lists.debian.org>:
Bug#629899; Package apache2.2-common. (Thu, 09 Jun 2011 13:51:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Massimo Manghi <massimo.manghi@unipr.it>:
Extra info received and forwarded to list. Copy sent to Debian Apache Maintainers <debian-apache@lists.debian.org>. (Thu, 09 Jun 2011 13:51:05 GMT) Full text and rfc822 format available.

Message #20 received at 629899@bugs.debian.org (full text, mbox):

From: Massimo Manghi <massimo.manghi@unipr.it>
To: Vincent Lefevre <vincent@vinc17.net>
Cc: 629899@bugs.debian.org
Subject: Re: Bug#629899: apache2: apr_sockaddr_info_get() failed / Could not reliably determine the server's FQDN
Date: Thu, 09 Jun 2011 15:46:40 +0200
On 06/09/2011 03:32 PM, Vincent Lefevre wrote:
> On 2011-06-09 14:41:45 +0200, Massimo Manghi wrote:
>> I've run into the same problem recently upgrading to Linux 2.6.38 on my
>> home's computer. Symptoms are the shell prompt doesn't show the hostname
>> I had assigned at install time, being the hostname displayed instead
>> then one passed through dhcp by the router. A similar problem doesn't
>> occur at work where we run our own dhcp server and names passed by dhcp
>> match consistently the ones in /etc/hosts
>>
>> Could a possible explanation for the workaround you found a latency in
>> the dhcp negotiation at boot time?
>
> Here DHCP *must not* be used to determine the FQDN. It is specified
> locally in the /etc/hosts file. This is important, in particular
> because one may want to run local services depending on it even when
> the external network is not available (the administrator may choose
> to use DHCP for the FQDN, but should not be forced to).
>

I agree with what you say and it doesn't rule out my hypothesis. I don't 
mean dhcp is needed, what I meant is that the problem is in the way the 
hostname and domain are fetched from the configuration. Using DHCP was 
illuminating because I was able to tell where the hostname returned came 
from (and didn't come from /etc/hosts as expected)

More specifically: definitions in /etc/hosts (that were part of the 
determination of the name returned by 'gethostname' prior to the kernel 
upgrade) are now are ignored and the proof is that not only Apache is
affected but also other applications.

Once again my question is: should the bug be moved against the kernel or 
libc?

 -- Massimo




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Apache Maintainers <debian-apache@lists.debian.org>:
Bug#629899; Package apache2.2-common. (Thu, 09 Jun 2011 14:12:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.net>:
Extra info received and forwarded to list. Copy sent to Debian Apache Maintainers <debian-apache@lists.debian.org>. (Thu, 09 Jun 2011 14:12:04 GMT) Full text and rfc822 format available.

Message #25 received at 629899@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.net>
To: Massimo Manghi <massimo.manghi@unipr.it>
Cc: 629899@bugs.debian.org
Subject: Re: Bug#629899: apache2: apr_sockaddr_info_get() failed / Could not reliably determine the server's FQDN
Date: Thu, 9 Jun 2011 16:08:49 +0200
On 2011-06-09 15:46:40 +0200, Massimo Manghi wrote:
> I agree with what you say and it doesn't rule out my hypothesis. I don't
> mean dhcp is needed, what I meant is that the problem is in the way the
> hostname and domain are fetched from the configuration. Using DHCP was
> illuminating because I was able to tell where the hostname returned came
> from (and didn't come from /etc/hosts as expected)

OK.

> More specifically: definitions in /etc/hosts (that were part of the
> determination of the name returned by 'gethostname' prior to the kernel
> upgrade) are now are ignored and the proof is that not only Apache is
> affected but also other applications.

You may see a different bug. On my machine, /etc/hosts is used by
both my fqdn program[*] and by ping. Indeed, just after changing
ypig.lip.ens-lyon.fr to ypig-test.lip.ens-lyon.fr in /etc/hosts,
I get:

ypig:~> fqdn
Nodename: ypig
FQDN: ypig-test.lip.ens-lyon.fr
ypig:~> ping ypig
PING ypig-test.lip.ens-lyon.fr (127.0.1.1) 56(84) bytes of data.
64 bytes from ypig-test.lip.ens-lyon.fr (127.0.1.1): icmp_req=1 ttl=64 time=0.029 ms
[...]

But how can I see what Apache chooses?

[*]

#!/usr/bin/env perl

use strict;
use POSIX;

my $nodename = (POSIX::uname)[1];
print "Nodename: $nodename\n";

my @ghbn = gethostbyname $nodename;
print "FQDN: $ghbn[0]\n";

> Once again my question is: should the bug be moved against the kernel or
> libc?

Definitely not the kernel or libc, unless something wrong occurs
at boot time.

-- 
Vincent Lefèvre <vincent@vinc17.net> - Web: <http://www.vinc17.net/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.net/blog/>
Work: CR INRIA - computer arithmetic / Arénaire project (LIP, ENS-Lyon)




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Apache Maintainers <debian-apache@lists.debian.org>:
Bug#629899; Package apache2.2-common. (Thu, 09 Jun 2011 14:21:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Massimo Manghi <massimo.manghi@unipr.it>:
Extra info received and forwarded to list. Copy sent to Debian Apache Maintainers <debian-apache@lists.debian.org>. (Thu, 09 Jun 2011 14:21:05 GMT) Full text and rfc822 format available.

Message #30 received at 629899@bugs.debian.org (full text, mbox):

From: Massimo Manghi <massimo.manghi@unipr.it>
To: Vincent Lefevre <vincent@vinc17.net>
Cc: <629899@bugs.debian.org>
Subject: Re: Bug#629899: apache2: apr_sockaddr_info_get() failed / Could not reliably determine the server's FQDN
Date: Thu, 09 Jun 2011 15:20:00 +0100
On Thu, 9 Jun 2011 16:08:49 +0200, Vincent Lefevre wrote:
>
> Definitely not the kernel or libc, unless something wrong occurs
> at boot time.

It's probably so, because I don't see why apache2 is getting it right
after the boot is over and you have gained access to the shell.
That's why I thought you were using dhcp at first.

 -- Massimo






Information forwarded to debian-bugs-dist@lists.debian.org, Debian Apache Maintainers <debian-apache@lists.debian.org>:
Bug#629899; Package apache2.2-common. (Thu, 09 Jun 2011 14:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.net>:
Extra info received and forwarded to list. Copy sent to Debian Apache Maintainers <debian-apache@lists.debian.org>. (Thu, 09 Jun 2011 14:45:03 GMT) Full text and rfc822 format available.

Message #35 received at 629899@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.net>
To: Massimo Manghi <massimo.manghi@unipr.it>
Cc: 629899@bugs.debian.org
Subject: Re: Bug#629899: apache2: apr_sockaddr_info_get() failed / Could not reliably determine the server's FQDN
Date: Thu, 9 Jun 2011 16:40:07 +0200
On 2011-06-09 15:20:00 +0100, Massimo Manghi wrote:
> On Thu, 9 Jun 2011 16:08:49 +0200, Vincent Lefevre wrote:
> >Definitely not the kernel or libc, unless something wrong occurs
> >at boot time.
> 
> It's probably so, because I don't see why apache2 is getting it right
> after the boot is over and you have gained access to the shell.
> That's why I thought you were using dhcp at first.

Yes, I confirm a possible problem with a recent libc or kernel at
boot time, but this isn't related to DHCP.

On my laptop, on which I do not use DHCP when I'm at home, with the
kernel 2.6.38-2:

Thu Mar 31 21:53:49 2011: Starting HTTP cache proxy server: wwwoffled (offline mode) done.

and with the kernel 2.6.39-1:

Sun Jun  5 22:50:14 2011: Starting HTTP cache proxy server: wwwoffled wwwoffled[5199] Warning: Failed to get name/IP address for host 'xvii' [No address associated with hostname].
Sun Jun  5 22:50:14 2011: (offline mode) done.

and no problems with a manual restart.

-- 
Vincent Lefèvre <vincent@vinc17.net> - Web: <http://www.vinc17.net/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.net/blog/>
Work: CR INRIA - computer arithmetic / Arénaire project (LIP, ENS-Lyon)




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Apache Maintainers <debian-apache@lists.debian.org>:
Bug#629899; Package apache2.2-common. (Thu, 09 Jun 2011 15:12:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Massimo Manghi <massimo.manghi@unipr.it>:
Extra info received and forwarded to list. Copy sent to Debian Apache Maintainers <debian-apache@lists.debian.org>. (Thu, 09 Jun 2011 15:12:03 GMT) Full text and rfc822 format available.

Message #40 received at 629899@bugs.debian.org (full text, mbox):

From: Massimo Manghi <massimo.manghi@unipr.it>
To: Vincent Lefevre <vincent@vinc17.net>
Cc: <629899@bugs.debian.org>
Subject: Re: Bug#629899: apache2: apr_sockaddr_info_get() failed / Could not reliably determine the server's FQDN
Date: Thu, 09 Jun 2011 16:09:29 +0100
On Thu, 9 Jun 2011 16:40:07 +0200, Vincent Lefevre wrote:
> On 2011-06-09 15:20:00 +0100, Massimo Manghi wrote:
>> On Thu, 9 Jun 2011 16:08:49 +0200, Vincent Lefevre wrote:
>> >Definitely not the kernel or libc, unless something wrong occurs
>> >at boot time.
>>
>> It's probably so, because I don't see why apache2 is getting it 
>> right
>> after the boot is over and you have gained access to the shell.
>> That's why I thought you were using dhcp at first.
>
> Yes, I confirm a possible problem with a recent libc or kernel at
> boot time, but this isn't related to DHCP.

I have no doubt: this has nothing to do with DHCP per se. DHCP was
useful to understand that gethostname (or uname) is not working
properly.

I looked up a possible bug already in the database against libc6 or the
kernel-image, but I haven't found any. I think the bug should have
'critical' as severity, since it can break applications started at
boot time that relay on the FQDN to work properly.

>
> On my laptop, on which I do not use DHCP when I'm at home, with the
> kernel 2.6.38-2:
>
> Thu Mar 31 21:53:49 2011: Starting HTTP cache proxy server: wwwoffled
> (offline mode) done.
>
> and with the kernel 2.6.39-1:
>
> Sun Jun  5 22:50:14 2011: Starting HTTP cache proxy server: wwwoffled
> wwwoffled[5199] Warning: Failed to get name/IP address for host 
> 'xvii'
> [No address associated with hostname].
> Sun Jun  5 22:50:14 2011: (offline mode) done.
>
> and no problems with a manual restart.

If this is the case the kernel-image package must clearly be the targed
of the bug report.

Do you want to file it yourself? This bug (#629899) could be merged
later with it as soon as it's been registered in the database.

 -- Massimo





Information forwarded to debian-bugs-dist@lists.debian.org, Debian Apache Maintainers <debian-apache@lists.debian.org>:
Bug#629899; Package apache2.2-common. (Thu, 09 Jun 2011 17:30:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.net>:
Extra info received and forwarded to list. Copy sent to Debian Apache Maintainers <debian-apache@lists.debian.org>. (Thu, 09 Jun 2011 17:30:03 GMT) Full text and rfc822 format available.

Message #45 received at 629899@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.net>
To: Massimo Manghi <massimo.manghi@unipr.it>
Cc: 629899@bugs.debian.org
Subject: Re: Bug#629899: apache2: apr_sockaddr_info_get() failed / Could not reliably determine the server's FQDN
Date: Thu, 9 Jun 2011 19:27:23 +0200
On 2011-06-09 16:09:29 +0100, Massimo Manghi wrote:
> On Thu, 9 Jun 2011 16:40:07 +0200, Vincent Lefevre wrote:
> >On 2011-06-09 15:20:00 +0100, Massimo Manghi wrote:
> >>It's probably so, because I don't see why apache2 is getting it right
> >>after the boot is over and you have gained access to the shell.
> >>That's why I thought you were using dhcp at first.
> >
> >Yes, I confirm a possible problem with a recent libc or kernel at
> >boot time, but this isn't related to DHCP.
> 
> I have no doubt: this has nothing to do with DHCP per se. DHCP was
> useful to understand that gethostname (or uname) is not working
> properly.

Actually I don't think this is the same bug. I cannot reproduce
this bug 629899 concerning apache2, while the bug with wwwoffle
has occurred every time since I upgraded to libc6 2.13.

> >and with the kernel 2.6.39-1:
> >
> >Sun Jun  5 22:50:14 2011: Starting HTTP cache proxy server: wwwoffled
> >wwwoffled[5199] Warning: Failed to get name/IP address for host 'xvii'
> >[No address associated with hostname].
> >Sun Jun  5 22:50:14 2011: (offline mode) done.

After I looked in the logs, I got this actually for the first time
after I upgraded to libc6 2.13.

> If this is the case the kernel-image package must clearly be the targed
> of the bug report.
> 
> Do you want to file it yourself? This bug (#629899) could be merged
> later with it as soon as it's been registered in the database.

I've reported the wwwoffle problem against wwwoffle because apache2
on the same machine doesn't have any problem:

  http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=629923

wwwoffle may do something special, and the maintainer could reassign
the bug to libc6 (with a testcase) if it appears that the problem
comes from libc6.

I suggest that you report a bug for the problem you get. If you can
reproduce it, you'll have at least more information than me...

-- 
Vincent Lefèvre <vincent@vinc17.net> - Web: <http://www.vinc17.net/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.net/blog/>
Work: CR INRIA - computer arithmetic / Arénaire project (LIP, ENS-Lyon)




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Apache Maintainers <debian-apache@lists.debian.org>:
Bug#629899; Package apache2.2-common. (Thu, 09 Jun 2011 23:09:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Massimo Manghi <massimo.manghi@unipr.it>:
Extra info received and forwarded to list. Copy sent to Debian Apache Maintainers <debian-apache@lists.debian.org>. (Thu, 09 Jun 2011 23:09:03 GMT) Full text and rfc822 format available.

Message #50 received at 629899@bugs.debian.org (full text, mbox):

From: Massimo Manghi <massimo.manghi@unipr.it>
To: Vincent Lefevre <vincent@vinc17.net>
Cc: <629899@bugs.debian.org>
Subject: Re: Bug#629899: apache2: apr_sockaddr_info_get() failed / Could not reliably determine the server's FQDN
Date: Fri, 10 Jun 2011 00:05:31 +0100
On Thu, 9 Jun 2011 19:27:23 +0200, Vincent Lefevre wrote:
> On 2011-06-09 16:09:29 +0100, Massimo Manghi wrote:
>> On Thu, 9 Jun 2011 16:40:07 +0200, Vincent Lefevre wrote:
>> >On 2011-06-09 15:20:00 +0100, Massimo Manghi wrote:
>> >>It's probably so, because I don't see why apache2 is getting it 
>> right
>> >>after the boot is over and you have gained access to the shell.
>> >>That's why I thought you were using dhcp at first.
>> >
>> >Yes, I confirm a possible problem with a recent libc or kernel at
>> >boot time, but this isn't related to DHCP.
>>
>> I have no doubt: this has nothing to do with DHCP per se. DHCP was
>> useful to understand that gethostname (or uname) is not working
>> properly.
>
> Actually I don't think this is the same bug. I cannot reproduce
> this bug 629899 concerning apache2, while the bug with wwwoffle
> has occurred every time since I upgraded to libc6 2.13.

OK. Wasn't this bug filed against apache2.2-common? Anyway I expect
every application based on apr calling apr_sockaddr_info_get to fail
with a similar reason.

>
>> >and with the kernel 2.6.39-1:
>> >
>> >Sun Jun  5 22:50:14 2011: Starting HTTP cache proxy server: 
>> wwwoffled
>> >wwwoffled[5199] Warning: Failed to get name/IP address for host 
>> 'xvii'
>> >[No address associated with hostname].
>> >Sun Jun  5 22:50:14 2011: (offline mode) done.
>
> After I looked in the logs, I got this actually for the first time
> after I upgraded to libc6 2.13.

>
>
> I've reported the wwwoffle problem against wwwoffle because apache2
> on the same machine doesn't have any problem:
>
>   http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=629923
>
> wwwoffle may do something special, and the maintainer could reassign
> the bug to libc6 (with a testcase) if it appears that the problem
> comes from libc6.
>
> I suggest that you report a bug for the problem you get. If you can
> reproduce it, you'll have at least more information than me...

I would file it against libc6 because my conjecture is that different
components layered on libc6 are failing when they probably call 
something
like uname or gethostname.

I cannot image what apr_* and  tcsh have in common except for libc6 
when
they are unable to determine the correct hostname.
Anyway, the bug seems not to be reproducible, not in a deterministic
way at least: tonight I booted my home machine and the hostname was 
displayed
correctly. I'll keep an eye on it to see if it shows up again.

 -- Massimo





Information forwarded to debian-bugs-dist@lists.debian.org, Debian Apache Maintainers <debian-apache@lists.debian.org>:
Bug#629899; Package apache2.2-common. (Fri, 10 Jun 2011 01:27:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.net>:
Extra info received and forwarded to list. Copy sent to Debian Apache Maintainers <debian-apache@lists.debian.org>. (Fri, 10 Jun 2011 01:27:04 GMT) Full text and rfc822 format available.

Message #55 received at 629899@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.net>
To: Massimo Manghi <massimo.manghi@unipr.it>
Cc: 629899@bugs.debian.org
Subject: Re: Bug#629899: apache2: apr_sockaddr_info_get() failed / Could not reliably determine the server's FQDN
Date: Fri, 10 Jun 2011 03:23:07 +0200
On 2011-06-10 00:05:31 +0100, Massimo Manghi wrote:
> On Thu, 9 Jun 2011 19:27:23 +0200, Vincent Lefevre wrote:
> >Actually I don't think this is the same bug. I cannot reproduce
> >this bug 629899 concerning apache2, while the bug with wwwoffle
> >has occurred every time since I upgraded to libc6 2.13.
> 
> OK. Wasn't this bug filed against apache2.2-common?

I did "reportbug apache2", but the bug was indeed files against
apache2.2-common.

> Anyway I expect every application based on apr calling
> apr_sockaddr_info_get to fail with a similar reason.

I filed a second bug against wwwoffle (which isn't based on libapr,
BTW).

[...]
> >wwwoffle may do something special, and the maintainer could reassign
> >the bug to libc6 (with a testcase) if it appears that the problem
> >comes from libc6.
> >
> >I suggest that you report a bug for the problem you get. If you can
> >reproduce it, you'll have at least more information than me...
> 
> I would file it against libc6 because my conjecture is that different
> components layered on libc6 are failing when they probably call something
> like uname or gethostname.

Perhaps, but one needs to know precisely which function is failing.
I doubt the libc6 developers know the wwwoffle internals.

I upgraded another machine (kernel and libc6), and this time, that's
spamassassin that was affected (spamassassin was not upgraded between
the two reboots). But again, I don't know whether this is related to
the problems with apache2 and wwwoffle (apparently not a hostname
problem, but still network related). Just in case:

  http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=629984

-- 
Vincent Lefèvre <vincent@vinc17.net> - Web: <http://www.vinc17.net/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.net/blog/>
Work: CR INRIA - computer arithmetic / Arénaire project (LIP, ENS-Lyon)




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Apache Maintainers <debian-apache@lists.debian.org>:
Bug#629899; Package apache2.2-common. (Fri, 29 Jul 2011 10:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.net>:
Extra info received and forwarded to list. Copy sent to Debian Apache Maintainers <debian-apache@lists.debian.org>. (Fri, 29 Jul 2011 10:51:09 GMT) Full text and rfc822 format available.

Message #60 received at 629899@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.net>
To: 629899@bugs.debian.org
Subject: Re: apache2: apr_sockaddr_info_get() failed / Could not reliably determine the server's FQDN
Date: Fri, 29 Jul 2011 12:47:55 +0200
On 2011-06-09 14:11:09 +0200, Vincent Lefevre wrote:
> After installing the new kernel 2.6.39-2-amd64 and rebooting, I got
> in /var/log/boot:
> 
> Thu Jun  9 13:41:49 2011: Starting web server: apache2apache2: apr_sockaddr_info_get() failed for ypig
> Thu Jun  9 13:41:51 2011: apache2: Could not reliably determine the server's fully qualified domain name, using 127.0.0.1 for ServerName
> Thu Jun  9 13:41:51 2011: .

Same problem just after I installed the new kernel
linux-image-3.0.0-1-amd64 and rebooted.

I also had the same problem on Jul 22 (though I hadn't changed the
kernel).

-- 
Vincent Lefèvre <vincent@vinc17.net> - Web: <http://www.vinc17.net/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.net/blog/>
Work: CR INRIA - computer arithmetic / Arénaire project (LIP, ENS-Lyon)




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Apache Maintainers <debian-apache@lists.debian.org>:
Bug#629899; Package apache2.2-common. (Fri, 29 Jul 2011 11:36:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.net>:
Extra info received and forwarded to list. Copy sent to Debian Apache Maintainers <debian-apache@lists.debian.org>. (Fri, 29 Jul 2011 11:36:12 GMT) Full text and rfc822 format available.

Message #65 received at 629899@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.net>
To: 629899@bugs.debian.org
Subject: Re: apache2: apr_sockaddr_info_get() failed / Could not reliably determine the server's FQDN
Date: Fri, 29 Jul 2011 13:33:22 +0200
retitle 629899 ap_get_local_host is broken (can't always determine the server's FQDN)
severity 629899 important
thanks

with potential security implications (depending on what Apache does
with the FQDN).

After reading the source, it appears that the ap_get_local_host
function in server/util.c is broken: it uses apr_sockaddr_info_get
to get the FQDN (thus does a network access) instead of using
gethostbyname (possibly an APR limitation); if gethostbyname is
not available on some systems, Apache could still use the current
method.

On my machine, the FQDN is specified via /etc/hosts, thus doesn't
depend on the network being set up. For instance, here we apparently
have dynamic DNS set-up, so that resolving the host name during the
boot via the DNS system may fail because the request is done too
early after the DHCP client has started.

Moreover, from a security point of view, it is a bad idea to use the
DNS system when the FQDN is defined locally, because the DNS system
may give incorrect information (e.g. when connecting via a public
access point).

-- 
Vincent Lefèvre <vincent@vinc17.net> - Web: <http://www.vinc17.net/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.net/blog/>
Work: CR INRIA - computer arithmetic / Arénaire project (LIP, ENS-Lyon)




Changed Bug title to 'ap_get_local_host is broken (can't always determine the server's FQDN)' from 'apache2: apr_sockaddr_info_get() failed / Could not reliably determine the server's FQDN' Request was from Vincent Lefevre <vincent@vinc17.net> to control@bugs.debian.org. (Fri, 29 Jul 2011 11:36:34 GMT) Full text and rfc822 format available.

Severity set to 'important' from 'normal' Request was from Vincent Lefevre <vincent@vinc17.net> to control@bugs.debian.org. (Fri, 29 Jul 2011 11:36:35 GMT) Full text and rfc822 format available.

Bug Marked as found in versions apache2/2.2.22-1. Request was from Vincent Lefevre <vincent@vinc17.net> to control@bugs.debian.org. (Fri, 17 Feb 2012 14:36:10 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Apache Maintainers <debian-apache@lists.debian.org>:
Bug#629899; Package apache2.2-common. (Sun, 19 Feb 2012 01:15:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Jean-Michel Vourgère" <jmv_deb@nirgal.com>:
Extra info received and forwarded to list. Copy sent to Debian Apache Maintainers <debian-apache@lists.debian.org>. (Sun, 19 Feb 2012 01:15:03 GMT) Full text and rfc822 format available.

Message #76 received at 629899@bugs.debian.org (full text, mbox):

From: "Jean-Michel Vourgère" <jmv_deb@nirgal.com>
To: 629899@bugs.debian.org
Subject: Re: ap_get_local_host is broken
Date: Sun, 19 Feb 2012 01:12:17 +0000
[Message part 1 (text/plain, inline)]
Hello

I recently found some strange behavior in dns resolution at boot time, when
eth0 has no ipv4 yet. (#500558)

Do you use DHCP for your other interface (eth0)?

What is the result of `grep CONCURRENCY /etc/init.d/rc' ?

Does the bug is still there if you set up a static ip address in
/etc/network/interfaces for your eth0 interface? Like
auto eth0
iface eth0 inet static address 192.168.0.1 netmask 255.255.255.0 gateway 192.168.0.1
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Apache Maintainers <debian-apache@lists.debian.org>:
Bug#629899; Package apache2.2-common. (Sun, 19 Feb 2012 11:27:16 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.net>:
Extra info received and forwarded to list. Copy sent to Debian Apache Maintainers <debian-apache@lists.debian.org>. (Sun, 19 Feb 2012 11:27:24 GMT) Full text and rfc822 format available.

Message #81 received at 629899@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.net>
To: Jean-Michel Vourgère <jmv_deb@nirgal.com>, 629899@bugs.debian.org
Subject: Re: Bug#629899: ap_get_local_host is broken
Date: Sun, 19 Feb 2012 12:22:42 +0100
Hi,

On 2012-02-19 01:12:17 +0000, Jean-Michel Vourgère wrote:
> I recently found some strange behavior in dns resolution at boot time, when
> eth0 has no ipv4 yet. (#500558)
> 
> Do you use DHCP for your other interface (eth0)?

Yes.

> What is the result of `grep CONCURRENCY /etc/init.d/rc' ?

CONCURRENCY=makefile
if [ "none" != "$CONCURRENCY" ] ; then
        test -s /etc/init.d/.depend.boot  || CONCURRENCY="none"
        test -s /etc/init.d/.depend.start || CONCURRENCY="none"
        test -s /etc/init.d/.depend.stop  || CONCURRENCY="none"
                CONCURRENCY="none"
        startpar -v      > /dev/null 2>&1 || CONCURRENCY="none"
case "$CONCURRENCY" in
                CONCURRENCY=makefile
        if [ makefile = "$CONCURRENCY" ]
        if [ makefile = "$CONCURRENCY" ]

> Does the bug is still there if you set up a static ip address in
> /etc/network/interfaces for your eth0 interface? Like
> auto eth0
> iface eth0 inet static address 192.168.0.1 netmask 255.255.255.0 gateway 192.168.0.1

I haven't tried. In any case, there's no reason to use eth0 (some
machines do not even have an Ethernet card).

-- 
Vincent Lefèvre <vincent@vinc17.net> - Web: <http://www.vinc17.net/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.net/blog/>
Work: CR INRIA - computer arithmetic / AriC project (LIP, ENS-Lyon)




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Apache Maintainers <debian-apache@lists.debian.org>:
Bug#629899; Package apache2.2-common. (Sun, 19 Feb 2012 22:06:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Jean-Michel Vourgère" <jmv_deb@nirgal.com>:
Extra info received and forwarded to list. Copy sent to Debian Apache Maintainers <debian-apache@lists.debian.org>. (Sun, 19 Feb 2012 22:06:03 GMT) Full text and rfc822 format available.

Message #86 received at 629899@bugs.debian.org (full text, mbox):

From: "Jean-Michel Vourgère" <jmv_deb@nirgal.com>
To: Vincent Lefevre <vincent@vinc17.net>
Cc: 629899@bugs.debian.org
Subject: Re: Bug#629899: ap_get_local_host is broken
Date: Sun, 19 Feb 2012 22:04:11 +0000
[Message part 1 (text/plain, inline)]
tags 629899 + moreinfo
thanks

On Sunday 19 February 2012 11:22:42 Vincent Lefevre wrote:
>> Does the bug is still there if you set up a static ip address in
>> /etc/network/interfaces for your eth0 interface? 
> I haven't tried. In any case, there's no reason to use eth0 (some
> machines do not even have an Ethernet card).

I know it sounds stupid, but try it, please.

The libapr1 resolver is known to fail for 127.0.0.1 if you have only
ipv6 on eth0, like when dhclient hasn't finished yet. Race problem on
boot.
See http://bugs.debian.org/500558
[signature.asc (application/pgp-signature, inline)]

Added tag(s) moreinfo. Request was from "Jean-Michel Vourgère" <jmv_deb@nirgal.com> to control@bugs.debian.org. (Sun, 19 Feb 2012 22:09:06 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Apache Maintainers <debian-apache@lists.debian.org>:
Bug#629899; Package apache2.2-common. (Wed, 22 Feb 2012 03:03:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Jean-Michel Vourgère" <jmv_deb@nirgal.com>:
Extra info received and forwarded to list. Copy sent to Debian Apache Maintainers <debian-apache@lists.debian.org>. (Wed, 22 Feb 2012 03:03:04 GMT) Full text and rfc822 format available.

Message #93 received at 629899@bugs.debian.org (full text, mbox):

From: "Jean-Michel Vourgère" <jmv_deb@nirgal.com>
To: 629899@bugs.debian.org
Subject: Re: ap_get_local_host is broken (can't always determine the server's FQDN)
Date: Wed, 22 Feb 2012 02:58:04 +0000
[Message part 1 (text/plain, inline)]
One can reproduce that bug by having IPv6 only on eth0 and no other interface
with IPv4 but localhost, and /etc/hosts matching `hostname` on any lo address.

Call (forward) trace:
ap_get_local_host
apr_sockaddr_info_get
find_addresses
call_resolver
getaddrinfo

... that fails since it is using AI_ADDRCONFIG flag on loopback interface

This bug is actually the same as 500558.
[signature.asc (application/pgp-signature, inline)]

Removed tag(s) moreinfo. Request was from "Jean-Michel Vourgère" <jmv_deb@nirgal.com> to control@bugs.debian.org. (Wed, 22 Feb 2012 03:06:02 GMT) Full text and rfc822 format available.

Changed Bug title to 'ap_get_local_host fails on loopback interface if eth0 has ipv6 only' from 'ap_get_local_host is broken (can't always determine the server's FQDN)' Request was from "Jean-Michel Vourgère" <jmv_deb@nirgal.com> to control@bugs.debian.org. (Wed, 22 Feb 2012 03:06:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Apache Maintainers <debian-apache@lists.debian.org>:
Bug#629899; Package apache2.2-common. (Wed, 22 Feb 2012 03:42:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.net>:
Extra info received and forwarded to list. Copy sent to Debian Apache Maintainers <debian-apache@lists.debian.org>. (Wed, 22 Feb 2012 03:42:03 GMT) Full text and rfc822 format available.

Message #102 received at 629899@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.net>
To: Jean-Michel Vourgère <jmv_deb@nirgal.com>, 629899@bugs.debian.org
Subject: Re: Bug#629899: ap_get_local_host is broken (can't always determine the server's FQDN)
Date: Wed, 22 Feb 2012 04:39:38 +0100
retitle 629899 ap_get_local_host is broken (can't always determine the server's FQDN)
thanks

I'll try to do some tests when I have the time. But there's
no reason eth0 would be IPv6 only here (unless there's a huge
bug in the kernel).

-- 
Vincent Lefèvre <vincent@vinc17.net> - Web: <http://www.vinc17.net/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.net/blog/>
Work: CR INRIA - computer arithmetic / AriC project (LIP, ENS-Lyon)




Changed Bug title to 'ap_get_local_host is broken (can't always determine the server's FQDN)' from 'ap_get_local_host fails on loopback interface if eth0 has ipv6 only' Request was from Vincent Lefevre <vincent@vinc17.net> to control@bugs.debian.org. (Wed, 22 Feb 2012 03:42:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Apache Maintainers <debian-apache@lists.debian.org>:
Bug#629899; Package apache2.2-common. (Wed, 22 Feb 2012 03:54:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.net>:
Extra info received and forwarded to list. Copy sent to Debian Apache Maintainers <debian-apache@lists.debian.org>. (Wed, 22 Feb 2012 03:54:04 GMT) Full text and rfc822 format available.

Message #109 received at 629899@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.net>
To: Jean-Michel Vourgère <jmv_deb@nirgal.com>, 629899@bugs.debian.org
Subject: Re: Bug#629899: ap_get_local_host is broken (can't always determine the server's FQDN)
Date: Wed, 22 Feb 2012 04:50:36 +0100
On 2012-02-22 02:58:04 +0000, Jean-Michel Vourgère wrote:
> This bug is actually the same as 500558.

Actually the error I get is different from the one in 500558.

Note that in my case, apache2 starts, but without being able to
get the fqdn.

-- 
Vincent Lefèvre <vincent@vinc17.net> - Web: <http://www.vinc17.net/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.net/blog/>
Work: CR INRIA - computer arithmetic / AriC project (LIP, ENS-Lyon)




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Apache Maintainers <debian-apache@lists.debian.org>:
Bug#629899; Package apache2.2-common. (Wed, 22 Feb 2012 13:45:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Jean-Michel Vourgère" <jmv_deb@nirgal.com>:
Extra info received and forwarded to list. Copy sent to Debian Apache Maintainers <debian-apache@lists.debian.org>. (Wed, 22 Feb 2012 13:45:09 GMT) Full text and rfc822 format available.

Message #114 received at 629899@bugs.debian.org (full text, mbox):

From: "Jean-Michel Vourgère" <jmv_deb@nirgal.com>
To: Vincent Lefevre <vincent@vinc17.net>, 629899@bugs.debian.org
Subject: Re: Bug#629899: ap_get_local_host is broken (can't always determine the server's FQDN)
Date: Wed, 22 Feb 2012 13:24:53 +0000
[Message part 1 (text/plain, inline)]
Hello Vincent

On Wednesday 22 February 2012 03:39:38 Vincent Lefevre wrote:
> I'll try to do some tests when I have the time. But there's
> no reason eth0 would be IPv6 only here (unless there's a huge
> bug in the kernel).

I'm prety sure your apache tries to start before dhclient has given
the server its IPv4. And you'll have the local link IPv6 address already.

The patch of libapr1 will fix your hostname problem:
https://issues.apache.org/bugzilla/show_bug.cgi?id=52709

Basically, all loopback IPv4 resolution is broken while dhclient is running
the first time, that is when you have IPv6 on eth0 but no IPv4 on it yet.
Then libapr1 internal function call_resolver is wrongly using AI_ADDRCONFIG
so that loopback IPv4 addresses are ignored.

That is why a manual restart (after dhclient completed) works.

I did understand your apache starts. Because you probably "Listen 80" rather
than "Listen 127.0.1.1:80". 127.0.1.1 resolution would fail then, just like the
resolution of ypig in your case. I tested it yesterday.

Believe me, the source of your problems are in libapr1, not in apache2 packages,
nor in the kernel.

Je te parie une bierre si tu veux! ;)
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Apache Maintainers <debian-apache@lists.debian.org>:
Bug#629899; Package apache2.2-common. (Wed, 22 Feb 2012 17:09:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.net>:
Extra info received and forwarded to list. Copy sent to Debian Apache Maintainers <debian-apache@lists.debian.org>. (Wed, 22 Feb 2012 17:09:04 GMT) Full text and rfc822 format available.

Message #119 received at 629899@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.net>
To: Jean-Michel Vourgère <jmv_deb@nirgal.com>
Cc: 629899@bugs.debian.org
Subject: Re: Bug#629899: ap_get_local_host is broken (can't always determine the server's FQDN)
Date: Wed, 22 Feb 2012 18:04:19 +0100
retitle 629899 ap_get_local_host fails when eth0 has IPv6 only (can't determine the FQDN), e.g. with DHCP at boot
thanks

Hi Jean-Michel,

Indeed according to various tests, I could reproduce the bug only
when eth0 has IPv6 only. It seems that this local link IPv6 address
appears only when the DHCP client (isc-dhcp-client 4.2.2-2) can
reach the DHCP server (strange behavior), and unfortunately,
dhclient doesn't log anything about it.

I've made the title a bit more clear so that users don't think this
bug doesn't concern them because they know they normally have IPv4.

On 2012-02-22 13:24:53 +0000, Jean-Michel Vourgère wrote:
> Hello Vincent
> 
> On Wednesday 22 February 2012 03:39:38 Vincent Lefevre wrote:
> > I'll try to do some tests when I have the time. But there's
> > no reason eth0 would be IPv6 only here (unless there's a huge
> > bug in the kernel).
> 
> I'm prety sure your apache tries to start before dhclient has given
> the server its IPv4. And you'll have the local link IPv6 address already.

Yes, if I add "ifconfig" (to show the eth0 status), before
"$APACHE2CTL start" in /etc/init.d/apache2, I cat get an eth0
with only the local link IPv6 address.

> I did understand your apache starts. Because you probably "Listen 80"
> rather than "Listen 127.0.1.1:80". 127.0.1.1 resolution would fail
> then, just like the resolution of ypig in your case. I tested it
> yesterday.

Yes, I have "Listen 80".

> Believe me, the source of your problems are in libapr1, not in
> apache2 packages, nor in the kernel.

Well, I'm not sure. There is at least a bug in libapr1 concerning
apr_sockaddr_info_get or a function called by it. But resolving
127.0.0.1 is not the right solution. Trying to resolve 127.0.0.1
on my machine will not give anything interesting: it's localhost
and nothing else, thus certainly not the FQDN. The usual way to
get the FQDN works even when eth0 has IPv6 only (I did the test).

-- 
Vincent Lefèvre <vincent@vinc17.net> - Web: <http://www.vinc17.net/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.net/blog/>
Work: CR INRIA - computer arithmetic / AriC project (LIP, ENS-Lyon)




Changed Bug title to 'ap_get_local_host fails when eth0 has IPv6 only (can't determine the FQDN), e.g. with DHCP at boot' from 'ap_get_local_host is broken (can't always determine the server's FQDN)' Request was from Vincent Lefevre <vincent@vinc17.net> to control@bugs.debian.org. (Wed, 22 Feb 2012 17:09:11 GMT) Full text and rfc822 format available.

Bug reassigned from package 'apache2.2-common' to 'libapr1'. Request was from "Jean-Michel Vourgère" <jmv_deb@nirgal.com> to control@bugs.debian.org. (Sun, 26 Feb 2012 10:15:16 GMT) Full text and rfc822 format available.

Bug No longer marked as found in versions apache2/2.2.22-1 and apache2/2.2.19-1. Request was from "Jean-Michel Vourgère" <jmv_deb@nirgal.com> to control@bugs.debian.org. (Sun, 26 Feb 2012 10:15:17 GMT) Full text and rfc822 format available.

Set Bug forwarded-to-address to 'https://issues.apache.org/bugzilla/show_bug.cgi?id=52709'. Request was from "Jean-Michel Vourgère" <jmv_deb@nirgal.com> to control@bugs.debian.org. (Sun, 26 Feb 2012 10:15:18 GMT) Full text and rfc822 format available.

Added tag(s) upstream and patch. Request was from "Jean-Michel Vourgère" <jmv_deb@nirgal.com> to control@bugs.debian.org. (Sun, 26 Feb 2012 10:15:18 GMT) Full text and rfc822 format available.

Reply sent to Stefan Fritsch <sf@debian.org>:
You have taken responsibility. (Mon, 28 May 2012 15:21:12 GMT) Full text and rfc822 format available.

Notification sent to Vincent Lefevre <vincent@vinc17.net>:
Bug acknowledged by developer. (Mon, 28 May 2012 15:21:12 GMT) Full text and rfc822 format available.

Message #134 received at 629899-close@bugs.debian.org (full text, mbox):

From: Stefan Fritsch <sf@debian.org>
To: 629899-close@bugs.debian.org
Subject: Bug#629899: fixed in apr 1.4.6-3
Date: Mon, 28 May 2012 15:17:29 +0000
Source: apr
Source-Version: 1.4.6-3

We believe that the bug you reported is fixed in the latest version of
apr, which is due to be installed in the Debian FTP archive:

apr_1.4.6-3.debian.tar.gz
  to main/a/apr/apr_1.4.6-3.debian.tar.gz
apr_1.4.6-3.dsc
  to main/a/apr/apr_1.4.6-3.dsc
libapr1-dbg_1.4.6-3_i386.deb
  to main/a/apr/libapr1-dbg_1.4.6-3_i386.deb
libapr1-dev_1.4.6-3_i386.deb
  to main/a/apr/libapr1-dev_1.4.6-3_i386.deb
libapr1_1.4.6-3_i386.deb
  to main/a/apr/libapr1_1.4.6-3_i386.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 629899@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Stefan Fritsch <sf@debian.org> (supplier of updated apr package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Mon, 28 May 2012 16:02:12 +0200
Source: apr
Binary: libapr1 libapr1-dev libapr1-dbg
Architecture: source i386
Version: 1.4.6-3
Distribution: unstable
Urgency: low
Maintainer: Debian Apache Maintainers <debian-apache@lists.debian.org>
Changed-By: Stefan Fritsch <sf@debian.org>
Description: 
 libapr1    - Apache Portable Runtime Library
 libapr1-dbg - Apache Portable Runtime Library - Debugging Symbols
 libapr1-dev - Apache Portable Runtime Library - Development Headers
Closes: 500558 629899
Changes: 
 apr (1.4.6-3) unstable; urgency=low
 .
   * Fix some issues with resolving loopback addresses of a protocol family
     that is not otherwise configured on a host. Many thanks to Jean-Michel
     Vourgère and Aurelien Jarno for debugging this.
     Closes: #500558, #629899 LP: #397393
   * Pull updates from upstream branch 1.4.x up to r1343251
   * Add some debug output in order to debug test failures on kfreebsd-i386.
Checksums-Sha1: 
 36e85e640fd420ad7b1936c3d12d9b66c06b483b 1416 apr_1.4.6-3.dsc
 c7fc5c0b0542c74ee1553faf9c67f3f91a647e41 22973 apr_1.4.6-3.debian.tar.gz
 19d2cfd89fc6e8f8d014f6ebee192f8f3a4425da 100192 libapr1_1.4.6-3_i386.deb
 42f22d7fd1378d273ff25728620e92f3379ec222 1107662 libapr1-dev_1.4.6-3_i386.deb
 c5a76736543fe30c336ac30fcaaf22df823fc81b 27406 libapr1-dbg_1.4.6-3_i386.deb
Checksums-Sha256: 
 a48d54845a94c353f45d3ac425591287d681a1e9de2ee8ddfaaa48338b58a7ca 1416 apr_1.4.6-3.dsc
 58aaa3ac81ea121d8c08d5fe301ac1db6432f3a1fe955d6c0f48af6d6133cceb 22973 apr_1.4.6-3.debian.tar.gz
 0a2f88c8a0da1e2ed7bb570ed4d7a4b53eb1f968c9e4a37f602006014d13f3df 100192 libapr1_1.4.6-3_i386.deb
 b02337a4fea60e38ec7fbabe1bbac1423e5802072dc226893f215c30f9e5f2b2 1107662 libapr1-dev_1.4.6-3_i386.deb
 ee06931763d2a44c5b0b9b1dd33e67dd1aeaec727ad6aeea20ea8610b51da224 27406 libapr1-dbg_1.4.6-3_i386.deb
Files: 
 b384ed73947490776ae581f9f8a2b945 1416 libs optional apr_1.4.6-3.dsc
 e056cf71569b96e6007fd15943be9845 22973 libs optional apr_1.4.6-3.debian.tar.gz
 389e46fbd85044819e1df936dc4f6ac1 100192 libs optional libapr1_1.4.6-3_i386.deb
 f13a5411dcc309afe90bcf7081b05489 1107662 libdevel optional libapr1-dev_1.4.6-3_i386.deb
 0a4bd89a390e13dd95f083bb03acb846 27406 debug extra libapr1-dbg_1.4.6-3_i386.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iD8DBQFPw4hPbxelr8HyTqQRAlmmAJ9WSvMcT+BJAnmetmB+oftEznOWewCeKWq/
9Fud3cskYOcZvr1ZZ4m2Sdo=
=LMcq
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Fri, 06 Jul 2012 07:55:12 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 18:00:48 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.